#!/usr/bin/python


import sys, os, shutil, math, commands, glob

from pylab import *

from PyFoam.Execution.UtilityRunner import UtilityRunner
from PyFoam.Execution.BasicRunner import BasicRunner
from PyFoam.RunDictionary.SolutionDirectory import SolutionDirectory
from PyFoam.RunDictionary.BlockMesh import BlockMesh 

from os import path

from subprocess import Popen
from subprocess import call

orig=SolutionDirectory(path.expandvars("$FOAM_RUN/windTunnel/baseline"),archive=None,paraviewLink=False)

alphas = [-0.25, 0.25, 1000]

for alpha in alphas:

	print "alpha:",alpha
	# clone the original case
	case=orig.cloneCase("modified%f" % alpha).name

	print "m4 -P blockMeshDict.m4 > blockMeshDict"
	# cd into case directory
	os.chdir(case)					

	# change the alpha value inside currentAlpha
	infilename='constant/polyMesh/currentAlpha'
	outfilename='constant/polyMesh/currentAlphaTemp'
	ifile = open( infilename, 'r')
	ofile = open(outfilename, 'w')
	lines = ifile.readlines()
	ofile.write(str(alpha))
	ifile.close()
	ofile.close()
	os.remove(infilename)
	os.rename(outfilename,infilename)

	# run m4
	os.chdir("constant/polyMesh")
	cmd='m4 -P blockMeshDict.m4 > blockMeshDict'
	pipefile = open('output', 'w')
	retcode = call(cmd,shell=True,stdout=pipefile)
	pipefile.close()
	os.remove('output')	
	os.chdir("../../..")	

	# run blockMesh
	print "blockMesh"
	os.chdir(case)
	cmd='blockMesh'
	pipefile = open('output', 'w')
	retcode = call(cmd,shell=True,stdout=pipefile)
	pipefile.close()
	os.remove('output')
	os.chdir("..")

	# run solver
	print "simpleFoam"
	os.chdir(case)
	cmd='simpleFoam > simpleFoamLog'
	pipefile = open('output', 'w')
	retcode = call(cmd,shell=True,stdout=pipefile)
	pipefile.close()
	os.remove('output')
	os.chdir("..")

	# calculate the pressure difference
	print "calcPressureDifference"
	os.chdir(case)
	cmd='calcPressureDifference > calcPressureDifferenceLog'
	pipefile = open('output', 'w')
	retcode = call(cmd,shell=True,stdout=pipefile)
	pipefile.close()
	os.remove('output')
	os.chdir("..")

